Summary: DHCPv6 - DHCP server and client for IPv6
Name:    dhcpv6
Version: 1.0.10
Release: 16%{?dist}
License: LGPLv2+
Group:   System Environment/Daemons
URL:     http://fedorahosted.org/dhcpv6/

Source0: http://dcantrel.fedorapeople.org/%{name}/%{name}-%{version}.tar.gz
Patch0:  %{name}-1.0.10-hwtype.patch
Patch1:  %{name}-1.0.10-noaddravail.patch
Patch2:  %{name}-1.0.10-dnslist.patch
Patch3:  %{name}-1.0.10-timer.patch
Patch4:  %{name}-1.0.10-relay-repl-buffer.patch
Patch5:  %{name}-1.0.10-dprintf.patch
Patch6:  %{name}-1.0.10-resolv.patch
Patch7:  %{name}-1.0.10-yy_init.patch
Patch8:  %{name}-1.0.10-gcc_intrin-ia64.patch
Patch9:  %{name}-1.0.10-relay-repl-msgID.patch
Patch10: %{name}-1.0.10-multiple-nameservers.patch
Patch11: %{name}-1.0.10-unique-IAIDs.patch
Patch12: %{name}-1.0.10-duplicates-check.patch
Patch13: %{name}-1.0.10-NULL-dereference.patch
Patch14: %{name}-1.0.10-getpid.patch
Patch15: %{name}-1.0.10-error-handling.patch
Patch16: %{name}-1.0.10-DUID-time.patch
Patch17: %{name}-1.0.10-multiple-IA.patch
Patch18: %{name}-1.0.10-DUID-consistency.patch
Patch19: %{name}-1.0.10-duid_match_llt.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: flex
BuildRequires: bison
BuildRequires: autoconf
BuildRequires: automake
BuildRequires: libtool
BuildRequires: kernel-headers
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(preun): initscripts
Requires(postun): initscripts

%description
Implements the Dynamic Host Configuration Protocol (DHCP) for Internet
Protocol version 6 (IPv6) networks in accordance with RFC 3315: Dynamic Host
Configuration Protocol for IPv6 (DHCPv6).  Consists of dhcp6s(8), the server
DHCP daemon, and dhcp6r(8), the DHCPv6 relay agent.

Install this package if you want to support dynamic configuration of IPv6
addresses and parameters on your IPv6 network.

%package -n dhcpv6-client
Summary:   DHCPv6 client
Requires:  initscripts >= 7.73
Group:     System Environment/Base
Obsoletes: dhcpv6_client

%description -n dhcpv6-client
Provides the client for the DHCPv6 protocol (RFC 3315) to support dynamic
configuration of IPv6 addresses and parameters.

%package -n libdhcp6client
Summary: The DHCPv6 client in a library for invocation by other programs
Group:   Development/Libraries

%description -n libdhcp6client
Provides the client for the DHCPv6 protocol (RFC 3315) to support dynamic
configuration of IPv6 addresses and parameters, in a library for invocation
by other programs.

%package -n libdhcp6client-devel
Summary:  Header files for development with the DHCPv6 client library
Group:    Development/Libraries
Requires: pkgconfig
Requires: libdhcp6client = %{version}-%{release}

%description -n libdhcp6client-devel
Header files for development with the DHCPv6 client library.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1

touch src/resolv_token.c src/lease_token.c

%build
CFLAGS="%{optflags} -fno-strict-aliasing" \
%configure
%{__make} %{?_smp_mflags}

%install
%{__rm} -rf %{buildroot}
%{__make} install DESTDIR=%{buildroot}

%{__rm} -rf %{buildroot}%{_libdir}/libdhcp6client.la

%{__mkdir} -p %{buildroot}/sbin
%{__mv} %{buildroot}%{_sbindir}/dhcp6c %{buildroot}/sbin/dhcp6c

%{__mkdir} -p %{buildroot}%{_localstatedir}/lib/%{name}

%post
/sbin/chkconfig --add dhcp6s
/sbin/chkconfig --add dhcp6r || :

%preun
if [ $1 = 0 ]; then
    /sbin/service dhcp6s status > /dev/null 2>&1
    if [ $? = 3 ]; then
        /sbin/service dhcp6s stop > /dev/null 2>&1
    fi

    /sbin/service dhcp6r status > /dev/null 2>&1
    if [ $? = 3 ]; then
        /sbin/service dhcp6r stop > /dev/null 2>&1
    fi

    /sbin/chkconfig --del dhcp6s
    /sbin/chkconfig --del dhcp6r || :
fi

%postun
if [ $1 -ge 1 ]; then
    /sbin/service dhcp6s condrestart >/dev/null 2>&1
    /sbin/service dhcp6r condrestart >/dev/null 2>&1 || :
fi

%post -n libdhcp6client -p /sbin/ldconfig

%postun -n libdhcp6client -p /sbin/ldconfig

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog COPYING.LIB LICENSE README TODO docs/*
%attr(754,root,root) %{_sbindir}/dhcp6s
%attr(754,root,root) %{_sbindir}/dhcp6r
%attr(755,root,root) %config %{_initrddir}/dhcp6s
%attr(755,root,root) %config %{_initrddir}/dhcp6r
%config(noreplace) %{_sysconfdir}/sysconfig/dhcp6s
%config(noreplace) %{_sysconfdir}/sysconfig/dhcp6r
%config(noreplace) %{_sysconfdir}/dhcp6s.conf
%{_mandir}/man8/dhcp6s.8.gz
%{_mandir}/man5/dhcp6s.conf.5.gz
%{_mandir}/man8/dhcp6r.8.gz
%attr(750,root,root) %dir %{_localstatedir}/lib/%{name}

%files -n dhcpv6-client
%defattr(-,root,root,-)
%attr(750,root,root) /sbin/dhcp6c
%doc AUTHORS ChangeLog COPYING.LIB LICENSE README TODO
%config(noreplace) %{_sysconfdir}/dhcp6c.conf
%{_mandir}/man8/dhcp6c.8.gz
%{_mandir}/man5/dhcp6c.conf.5.gz
%attr(750,root,root) %dir %{_localstatedir}/lib/dhcpv6

%files -n libdhcp6client
%defattr(-,root,root,-)
%{_libdir}/libdhcp6client-*.so.*

%files -n libdhcp6client-devel
%defattr(0644,root,root,0755)
%{_includedir}/*
%{_libdir}/libdhcp6client.a
%{_libdir}/libdhcp6client.so
%{_libdir}/pkgconfig/libdhcp6client.pc

%changelog
* Thu Oct 30 2008 David Cantrell <dcantrell@redhat.com> - 1.0.10-16
- Remove the ADVERTISE/REPLY patch for option 24 as it is unnecessary,
  the problem was in our test driver scripts for the TAHI suite
  Resolves: rhbz#426899

* Thu Oct 23 2008 David Cantrell <dcantrell@redhat.com> - 1.0.10-15
- Allow users to configure dhcp6s to return only option 24 for
  ADVERTISE and REPLY messages
  Related: rhbz#426899

* Tue Oct 21 2008 David Cantrell <dcantrell@redhat.com> - 1.0.10-14
- Add directive for dhcp6s.conf that lets users enable the 'only
  send option 23 for ADVERTISE messages' setting
  Related: rhbz#426899

* Fri Oct 17 2008 David Cantrell <dcantrell@redhat.com> - 1.0.10-13
- For all ADVERTISE messages, clear out option 24
  Resolves: rhbz#426899

* Thu Oct 16 2008 David Cantrell <dcantrell@redhat.com> - 1.0.10-12
- More fixes related to not returning option 24 in ADVERTISE messages
  Resolves: rhbz#426899

* Mon Oct 13 2008 David Cantrell <dcantrell@redhat.com> - 1.0.10-11
- Do not return option 24 (domain list) in ADVERTISE messages
  Resolves: rhbz#426899

* Tue Oct 07 2008 David Cantrell <dcantrell@redhat.com> - 1.0.10-10
- Keep DUID consistent
  Resolves: rhbz#377101
- Match DUID LLT time field on client-server communications
  Resolves: rhbz#365501

* Tue Sep 30 2008 David Cantrell <dcantrell@redhat.com> - 1.0.10-9
- Revert invalid unexpected options patch
  Related: rhbz#426899

* Tue Sep 16 2008 David Cantrell <dcantrell@redhat.com> - 1.0.10-8
- Make sure DUID is saved in dhcp6s as it is in dhcp6c.  This keeps the DUID
  consistent in dhcp6s and keeps the DUID time field correct.
  Resolves: rhbz#377101
  Resolves: rhbz#365501
- Do not send the domain list to the client unless it's a requested option
  Resolves: rhbz#426899

* Thu Jul 17 2008 David Cantrell <dcantrell@redhat.com> - 1.0.10-7
- Compile with -fno-strict-aliasing
  Related: rhbz#439526

* Tue Jul 15 2008 David Cantrell <dcantrell@redhat.com> - 1.0.10-6
- Support multiple IA options
  Resolves: rhbz#439526
  Resolves: rhbz#365531
  Resolves: rhbz#365651
  Resolves: rhbz#426899
  Resolves: rhbz#365661
- DUID type 1 time is time since January 1, 2000 (UTC), modulo 2^32
  Resolves: rhbz#365501

* Fri May 23 2008 David Cantrell <dcantrell@redhat.com> - 1.0.10-5
- Do not dereference a possible NULL pointer in dhcp6c
  Resolves: rhbz#439942
- Check DUID and IAID for duplicate hosts
  Resolves: rhbz#440330
- Add error handling during initialization of dhcp6c
  Resolves: rhbz#449052
- Log correct PID after daemonizing in dhcp6c
  Resolves: rhbz#449051
- Handle multiple nameservers in option-23
  Resolves: rhbz#449053
- Use last 4 bytes of MAC address to generate IAID
  Resolves: rhbz#449054

* Wed Apr 09 2008 David Cantrell <dcantrell@redhat.com> - 1.0.10-4
- Do not send Message-ID from dhcp6r except for RELAY-FORWARD and RELAY-REPL
  Resolves: rhbz#440440

* Tue Mar 11 2008 David Cantrell <dcantrell@redhat.com> - 1.0.10-3
- Fix hwtype in calculate_duid_len()
  Resolves: rhbz#377101
- Do not return IA_NA option with status code set to NoAddrAvail
  Resolves: rhbz#365531
  Related: rhbz#426899
- Add domain list option check to specify DNS list
  Related: rhbz#377131
- Update 'now' whenever checking expiration for each timer
  Resolves: rhbz#365501
- Verify length of buffer for RELAY_REPL correctly
  Resolves: rhbz#365551
  Related: rhbz#365521
  Related: rhbz#365531
  Related: rhbz#365541
  Related: rhbz#365581
  Related: rhbz#365591
  Related: rhbz#365601
  Related: rhbz#365631
  Related: rhbz#365641
  Related: rhbz#365651
  Related: rhbz#376871
- Support updating /etc/resolv.conf when network-functions is not available
  Related: rhbz#377131
- Remove gcc_intrin.h workaround for ia64
  Related: rhbz#429074

* Tue Mar 11 2008 David Cantrell <dcantrell@redhat.com> - 1.0.10-2
- Fix hwtype in calculate_duid_len()
  Resolves: rhbz#377101
- Do not return IA_NA option with status code set to NoAddrAvail
  Resolves: rhbz#365531
- Add domain list option check to specify DNS list
  Related: rhbz#377131
- Update 'now' whenever checking expiration for each timer
  Resolves: rhbz#365501
- Verify length of buffer for RELAY_REPL correctly
  Resolves: rhbz#365551
- Support updating /etc/resolv.conf when network-functions is not available
  Related: rhbz#377131
- Remove gcc_intrin.h workaround for ia64
  Related: rhbz#429074

* Mon Jan 21 2008 David Cantrell <dcantrell@redhat.com> - 1.0.10-1
- Allow libdhcp6client.so to dlopen()
  Related: rhbz#429738

* Fri Jan 18 2008 David Cantrell <dcantrell@redhat.com> - 1.0.9-1
- Transmit server and client DUID in responses to client
  Related: rhbz#377111

* Thu Jan 17 2008 David Cantrell <dcantrell@redhat.com> - 1.0.8-1
- Do not send DNS options in Confirm message
  Resolves: rhbz#376871

* Wed Jan 16 2008 David Cantrell <dcantrell@redhat.com> - 1.0.7-1
- Fix dhcp6c re-assign of IPv6 global address after Confirm/Reply msg exchange
  Resolves: rhbz#249466
- Make dhcp6c retransmit Confirm message in expected duration
  Resolves: rhbz#251192
- Fix value dhcp6c stores to elapsed time option in Solicit message
  Resolves: rhbz#249451
- Make dhcp6c ignore Reply message that contains IA_NA with T1 > T2
  Resolves: rhbz#254194
- Do not let dhcp6c remove leases that are not on the updated list
  Resolves: rhbz#265761
- Fix RFC 3646 compliance
  Resolves: rhbz#382331
- /etc/init.d/dhcp6s line continuation in description fix
  Resolves: rhbz#204713
- Avoid global library symbol collisions in libdhcp6client
  Resolves: rhbz#216188
- Init script fixes (LSB compliance)
  Resolves: rhbz#237970
- Match time field of received DHCPv6 Advertise message
  Resolves: rhbz#365501
- Include Advertise message in Relay-Repl message
  Resolves: rhbz#365521
- Include valid IA_Address option in Reply messages
  Resolves: rhbz#365531
- Do not return Reply message when receiving a Confirm message via unicast
  Resolves: rhbz#365541
- Set status code of Reply message to NotOnLink when necessary
  Resolves: rhbz#365551
- Do not send unexpected Reply messages to client
  Resolves: rhbz#365551
- Set lifetime of Reply messages to zero
  Resolves: rhbz#365581
- Include NoBinding status in the IA_NA option in Reply messages when needed
  Resolves: rhbz#365591
- Do not return Reply message when receiving a Rebind message via unicast
  Resolves: rhbz#365601
- Do not return Advertise message when receiving a Solicit message with SID
  Resolves: rhbz#365621
- Do not return Reply message when receiving a Confirm message with SID
  Resolves: rhbz#365631
- Do not return Reply message when receiving a Rebind message with SID
  Resolves: rhbz#365641
- Check IA options of the received Advertise message
  Resolves: rhbz#365651
- Set status code of Advertise message to NoAddrAvail when necessary
  Resolves: rhbz#365661
- Fix About RT(Retransmission Time) problem
  Resolves: rhbz#376901
- Fix About RD(Retransmission Duration) problem
  Resolves: rhbz#376921
- Send Rebind messages correctly
  Resolves: rhbz#376931
- Send Renew messages correctly
  Resolves: rhbz#376941
- Send Echo Reply to calling server correctly
  Resolves: rhbz#377091
- Keep DUID consistent between reboots and such
  Resolves: rhbz#377101
- Honor requested options from the client
  Resolves: rhbz#377111
- Send DNS Query message correctly
  Resolves: rhbz#377131
- Send Information Request message correctly
  Resolves: rhbz#377161
- Find correct option code
  Resolves: rhbz#377191
- Do not return Reply message when receiving an Information Request message
  via unicast
  Resolves: rhbz#377221
- Do not display invalid error messages on terminal when running dhcp6r
  Resolves: rhbz#377231
- Do not include non-requested options in Reply messages
  Resolves: rhbz#426899

* Fri Dec 21 2007 David Cantrell <dcantrell@redhat.com> - 1.0.4-1
- Rebase to dhcpv6-1.0.4
- Renamed dhcpv6_client package to dhcpv6-client
- Added libdhcp6client-static package
- BR kernel-headers

* Thu Dec 13 2007 David Cantrell <dcantrell@redhat.com> - 0.10-35
- Init script fixes
  Resolves: rhbz#237970

* Tue Dec 04 2007 David Cantrell <dcantrell@redhat.com> - 0.10-34
- Store elapsed time value correctly in solicit message
  Resolves: rhbz#249451
- Reassign global address after confirm/reply in dhcp6c
  Resolves: rhbz#249466
- Retransmit confirm message in expected duration in dhcp6c
  Resolves: rhbz#251192
- In dhcp6c, ignore reply message that contains IA_NA with T1 > T2
  Resolves: rhbz#254194
- Do not let dhcp6c remove leases that are not on the updated list
  Resolves: rhbz#265761

* Wed Dec 13 2006 David Cantrell <dcantrell@redhat.com> - 0.10-33
- server6_addr.conf is not required for dhcp6s
- Resolves: rhbz#217309
- Man page for dhcp6s.conf should reference server-preference
- Resolves: rhbz#217308

* Fri Sep 29 2006 David Cantrell <dcantrell@redhat.com> - 0.10-32
- Line continuation slashes for init script description (#204713)

* Fri Aug 18 2006 Jesse Keating <jkeating@redhat.com> - 0.10-31
- rebuilt with latest binutils to pick up 64K -z commonpagesize on ppc*
  (#203001)

* Tue Jul 18 2006 Jason Vas Dias <jvdias@redhat.com> - 0.10-30
- fix bug 196429: 
  Allow clients from dhcpv6-0.10<=16 to get addresses. 
  >16, the server sent the prefix length; this is now
  conditional on the client sending the DHC6OPT_REQUEST_PREFIX,
  and can be disabled by the 'use-ra-prefix' dhcp6c.conf or 
  dhcp6s.conf setting. With the upstream version, the only
  way to set the clients' address prefixes was by router
  advertisement.

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 0.10-29.1
- rebuild

* Wed Jun 28 2006 Peter Jones <pjones@redhat.com> - 0.10-29
- getnameinfo needs the size of the incoming data, not NS_MAXHOST

* Thu Jun 22 2006 David Cantrell <dcantrell@redhat.com> - 0.10-28
- If link is down, exit rather than loop indefinitely (#195250)

* Tue Jun 20 2006 Peter Jones <pjones@redhat.com> - 0.10-27
- don't patch using autoconf, do it in the spec file so it can be
  patched on top of

* Thu Jun 08 2006 Jason Vas Dias<jvdias@redhat.com> 0.10-26
- libdhcp6client fix to retry bind() to linklocal address
  on EADDRNOTAVAIL for up to 5 seconds to give kernel time
  to create linklocal address.

* Fri May 26 2006 Jason Vas Dias<jvdias@redhat.com> 0.10-24.1
- misc libdhcp6client fixes

* Fri May 19 2006 Jason Vas Dias<jvdias@redhat.com> 0.10-24
- build libdhcp6client with -soname

* Wed May 17 2006 Jason Vas Dias<jvdias@redhat.com> 0.10-22
- Thanks, Karsten. Now building with libdhcp6client enabled.

* Wed May 17 2006 Karsten Hopp <karsten@redhat.de> 0.10-21
- change buildrequires from openssl top openssl-devel so that
  the configure checks actually work

* Sun May 14 2006 Jason Vas Dias <jvdias@redhat.com> - 0.10-20
- Produce the libdhcp6client library for invoking dhcp6c from
  within other programs.

* Wed May 10 2006 Jason Vas Dias <jvdias@redhat.com> - 0.10-18
- Make server send client the IPv6 address prefix in address lease;
  make client use it 
- prevent netlink.c generating error log message for NLMSG_DONE
- fix netlink.c IFLA_PROTINFO handling now that kernel defines it
- fix memory leak in client6_addr create_iaid
- disable 'install -s' for binaries

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 0.10-16.1
- bump again for double-long bug on ppc(64)

* Tue Feb 07 2006 Jason Vas Dias <jvdias@redhat.com> - 0.10-16
- rebuild for new gcc, glibc, glibc-kernheaders

* Sun Dec 18 2005 Jason Vas Dias<jvdias@redhat.com> - 0.10-15.2
- rebuild for new gcc & flex

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Wed Nov  9 2005 Tomas Mraz <tmraz@redhat.com> - 0.10-15
- rebuilt with new openssl

* Mon Aug 15 2005 Jason Vas Dias <jvdias@redhat.com>
- fix bug 165882: allow client to configure an interface which
  does not have an IPv4 address ( use getifaddrs instead of
  ioctl(sockfd, SIOGIFCONF, ...)
- fix bug 165884 (possibly!): force use of glibc's getifaddrs,
  not internal getifaddrs implementation

* Fri Apr 01 2005 Florian La Roche <laroche@redhat.com>
- made perms for /var/lib/dhcpv6 the same

* Fri Mar 25 2005 Florian La Roche <laroche@redhat.com>
- add "exit 0" to postun script

* Thu Jan 13 2005 Jason Vas Dias <jvdias@redhat.com> - 0.10-11
- Fix misc. compiler warnings and ms-dos formatted man-pages

* Wed Jan 12 2005 Jason Vas Dias <jvdias@redhat.com> - 0.10-11
- Add 'prefix-delegation-interface' option to allow write
- of radvd interface configuration other than that for 
- the interface the lease was received on.

* Mon Jan 10 2005 Jason Vas Dias <jvdias@redhat.com> - 0.10-10
- Fix bug 144585: dhcp6c wasn't writing radvd.conf in prefix delegation mode

* Sun Jan 9  2005 Jason Vas Dias <jvdias@redhat.com> - 0.10-10
- Add Relay Agent support. Thanks to  Brian Bluesker<bbuesker@qualcomm.com>
- for the patch to add relay support to the server and for submitting the 
- patch originally contributed by Cristian Cadar of NEC Europe to 
- DHCPv6-developer  mailing list.

* Fri Jan 7  2005 Jason Vas Dias <jvdias@redhat.com> - 0.10-9
- fix bug 143728: SEGV core on resolv.conf + radvd.conf update -
- yywrap()'s must return 1

* Mon Oct 18 2004 Jason Vas Dias <jvdias@redhat.com> - 0.10-7
- fix bug 136146: clean up code - prevent compiler warnings

* Mon Sep 13 2004 Jason Vas Dias <jvdias@redhat.com> - 0.10-6
- fix bug 132468 for bug 125712: invoke change_resolv_conf

* Mon Sep 13 2004 Bill Nottingham <notting@redhat.com> - 0.10-5
- don't run by default
- add chkconfig prereqs, postun script, etc.

* Thu Sep  2 2004 Jason Vas Dias <jvdias@redhat.com> - 0.10-3/4
- fixed missing %defattr for dhcpv6_client - bug 131638

* Mon Aug 30 2004 Jason Vas Dias <jvdias@redhat.com> - 0.10-2
- Split into two packages: dhcpv6-*, containing server only,
- and dhcpv6_client-*, containing client only.

* Thu Aug 26 2004 Jason Vas Dias <jvdias@redhat.com> - 0.10-1 
- Initial build.

